jQuery(document).ready(function ($) {
    $('.ajax-product-list').each(function () {
        const $instance = $(this);
        const instanceId = $instance.data('instance-id');

        function loadProducts(paged = 1, perPage = 12, sort = 'default') {
            const container = $instance.find('.product-list-container');
            const cats = $instance.find('.product-list-cats').val();
            const tags = $instance.find('.product-list-tags').val();
            const ss = $instance.find('.product-list-s').val();

            // Set opacity of product entries to 0.5 before loading
            container.find('.entry.loop-entry').css('opacity', '0.5');

            // Perform the AJAX request
            $.ajax({
                url: aplAjax.ajaxUrl,
                method: 'POST',
                data: {
                    action: 'load_products',
                    paged: paged,
                    per_page: perPage,
                    cats: cats,
                    tags: tags,
                    s: ss,
                    sort: sort,
                    instance_id: instanceId,
                },
                success: function (response) {
                    // Wait until the response is received to update the products
                    container.html(response.html);

                    // load more
                    $instance.find('.more').html(response.more);

                     // Update pagination HTML
    $instance.find('.apl-pagination').html(response.pagination);

    // Update result count
    if (response.result_count) {
        $instance.find('.apl-result-count').html(response.result_count);
    }

                    // Reset opacity of loaded product entries to 1
                    container.find('.entry.loop-entry').css('opacity', '1');


         // load more btn
        const loadMoreBtn = $instance.find('button.load-more');
        loadMoreBtn.on('click', function () {
			loadMoreBtn.addClass('loading');
			loadMoreBtn.prop('disabled', true);
			var activeBtn = $instance.find('.pagination-controls button.active');
			var nextBtn = activeBtn.length ? activeBtn.next('button') : $instance.find('.pagination-controls button:first-child');
			nextBtn.trigger('click');
        });



                },
                error: function () {
                    container.html('<p>Error loading products.</p>');

                    // Reset opacity to 1 in case of an error
                    container.find('.entry.loop-entry').css('opacity', '1');
                }
            });



        }

        // Load products on page load
        /*
        const initialSort = $instance.find('.sorting-dropdown').val() || 'default';
        const initialPerPage = $instance.find('.pagination-controls button.active').data('per-page') || $instance.find('.pagination-controls button:first-child').data('n') || 12;

        loadProducts(1, initialPerPage, initialSort);
		*/
        // Pagination controls
        $instance.find('.pagination-controls button').on('click', function () {
			$instance.find('.pagination-controls button').removeClass('active');
			$(this).addClass('active');
            const perPage = $(this).data('per-page');
            const sort = $instance.find('.sorting-dropdown').val();
            loadProducts(1, perPage, sort);
        });


		// load more in statrt
        const loadMoreBtn = $instance.find('button.load-more');
        loadMoreBtn.on('click', function () {
			loadMoreBtn.addClass('loading');
			loadMoreBtn.prop('disabled', true);
			var activeBtn = $instance.find('.pagination-controls button.active');
			var nextBtn = activeBtn.length ? activeBtn.next('button') : $instance.find('.pagination-controls button:first-child');
			nextBtn.trigger('click');
        });


        // Sorting dropdown
        $instance.find('.sorting-dropdown').on('change', function () {
            const sort = $(this).val();
            const perPage = $instance.find('.pagination-controls button.active').data('per-page') || $instance.find('.pagination-controls button:first-child').data('n') || 12;
            loadProducts(1, perPage, sort);
        });

        // Toggle grid and list view
        $instance.find('.toggle-view').on('click', function () {
			$instance.find('.toggle-view').removeClass('active');
			$(this).addClass('active');
            if ($(this).hasClass('grid-view')) {
                $instance.addClass('ajax-grid');
            } else {
                $instance.removeClass('ajax-grid');
            }
        });
    });
    // remove loading calss from all btn on page load
    $('a.add_to_cart_button').removeClass('loading');
});
